Index: /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.designer.cs
===================================================================
--- /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.designer.cs	(revision 6839)
+++ /branches/ClientUserManagement/HeuristicLab.Services.Access.DataAccess/3.3/ClientManagement.designer.cs	(revision 6840)
@@ -1870,124 +2074,151 @@
     partial void OnVersionChanged();
     #endregion
-
-    public Plugin() {
-      this._ResourcePlugins = new EntitySet<ResourcePlugin>(new Action<ResourcePlugin>(this.attach_ResourcePlugins), new Action<ResourcePlugin>(this.detach_ResourcePlugins));
-      OnCreated();
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_Id", DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true, IsDbGenerated = true)]
-    public System.Guid Id {
-      get {
-        return this._Id;
-      }
-      set {
-        if ((this._Id != value)) {
-          this.OnIdChanging(value);
-          this.SendPropertyChanging();
-          this._Id = value;
-          this.SendPropertyChanged("Id");
-          this.OnIdChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_Name", DbType = "NVarChar(MAX) NOT NULL", CanBeNull = false)]
-    public string Name {
-      get {
-        return this._Name;
-      }
-      set {
-        if ((this._Name != value)) {
-          this.OnNameChanging(value);
-          this.SendPropertyChanging();
-          this._Name = value;
-          this.SendPropertyChanged("Name");
-          this.OnNameChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_StrongName", DbType = "NVarChar(MAX)")]
-    public string StrongName {
-      get {
-        return this._StrongName;
-      }
-      set {
-        if ((this._StrongName != value)) {
-          this.OnStrongNameChanging(value);
-          this.SendPropertyChanging();
-          this._StrongName = value;
-          this.SendPropertyChanged("StrongName");
-          this.OnStrongNameChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_Version", DbType = "NVarChar(20) NOT NULL", CanBeNull = false)]
-    public string Version {
-      get {
-        return this._Version;
-      }
-      set {
-        if ((this._Version != value)) {
-          this.OnVersionChanging(value);
-          this.SendPropertyChanging();
-          this._Version = value;
-          this.SendPropertyChanged("Version");
-          this.OnVersionChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Plugin_ResourcePlugin", Storage = "_ResourcePlugins", ThisKey = "Id", OtherKey = "PluginId")]
-    public EntitySet<ResourcePlugin> ResourcePlugins {
-      get {
-        return this._ResourcePlugins;
-      }
-      set {
-        this._ResourcePlugins.Assign(value);
-      }
-    }
-
-    public event PropertyChangingEventHandler PropertyChanging;
-
-    public event PropertyChangedEventHandler PropertyChanged;
-
-    protected virtual void SendPropertyChanging() {
-      if ((this.PropertyChanging != null)) {
-        this.PropertyChanging(this, emptyChangingEventArgs);
-      }
-    }
-
-    protected virtual void SendPropertyChanged(String propertyName) {
-      if ((this.PropertyChanged != null)) {
-        this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
-      }
-    }
-
-    private void attach_ResourcePlugins(ResourcePlugin entity) {
-      this.SendPropertyChanging();
-      entity.Plugin = this;
-    }
-
-    private void detach_ResourcePlugins(ResourcePlugin entity) {
-      this.SendPropertyChanging();
-      entity.Plugin = null;
-    }
-  }
-
-  [global::System.Data.Linq.Mapping.TableAttribute(Name = "dbo.ResourcePlugin")]
-  public partial class ResourcePlugin : INotifyPropertyChanging, INotifyPropertyChanged {
-
-    private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
-
-    private System.Guid _ResourceId;
-
-    private System.Guid _PluginId;
-
-    private EntityRef<Plugin> _Plugin;
-
-    private EntityRef<Resource> _Resource;
-
+		
+		public Plugin()
+		{
+			this._ResourcePlugins = new EntitySet<ResourcePlugin>(new Action<ResourcePlugin>(this.attach_ResourcePlugins), new Action<ResourcePlugin>(this.detach_ResourcePlugins));
+			OnCreated();
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Id", DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true, IsDbGenerated=true)]
+		public System.Guid Id
+		{
+			get
+			{
+				return this._Id;
+			}
+			set
+			{
+				if ((this._Id != value))
+				{
+					this.OnIdChanging(value);
+					this.SendPropertyChanging();
+					this._Id = value;
+					this.SendPropertyChanged("Id");
+					this.OnIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Name", DbType="NVarChar(MAX) NOT NULL", CanBeNull=false)]
+		public string Name
+		{
+			get
+			{
+				return this._Name;
+			}
+			set
+			{
+				if ((this._Name != value))
+				{
+					this.OnNameChanging(value);
+					this.SendPropertyChanging();
+					this._Name = value;
+					this.SendPropertyChanged("Name");
+					this.OnNameChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_StrongName", DbType="NVarChar(MAX)")]
+		public string StrongName
+		{
+			get
+			{
+				return this._StrongName;
+			}
+			set
+			{
+				if ((this._StrongName != value))
+				{
+					this.OnStrongNameChanging(value);
+					this.SendPropertyChanging();
+					this._StrongName = value;
+					this.SendPropertyChanged("StrongName");
+					this.OnStrongNameChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_Version", DbType="NVarChar(20) NOT NULL", CanBeNull=false)]
+		public string Version
+		{
+			get
+			{
+				return this._Version;
+			}
+			set
+			{
+				if ((this._Version != value))
+				{
+					this.OnVersionChanging(value);
+					this.SendPropertyChanging();
+					this._Version = value;
+					this.SendPropertyChanged("Version");
+					this.OnVersionChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Plugin_ResourcePlugin", Storage="_ResourcePlugins", ThisKey="Id", OtherKey="PluginId")]
+		public EntitySet<ResourcePlugin> ResourcePlugins
+		{
+			get
+			{
+				return this._ResourcePlugins;
+			}
+			set
+			{
+				this._ResourcePlugins.Assign(value);
+			}
+		}
+		
+		public event PropertyChangingEventHandler PropertyChanging;
+		
+		public event PropertyChangedEventHandler PropertyChanged;
+		
+		protected virtual void SendPropertyChanging()
+		{
+			if ((this.PropertyChanging != null))
+			{
+				this.PropertyChanging(this, emptyChangingEventArgs);
+			}
+		}
+		
+		protected virtual void SendPropertyChanged(String propertyName)
+		{
+			if ((this.PropertyChanged != null))
+			{
+				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
+			}
+		}
+		
+		private void attach_ResourcePlugins(ResourcePlugin entity)
+		{
+			this.SendPropertyChanging();
+			entity.Plugin = this;
+		}
+		
+		private void detach_ResourcePlugins(ResourcePlugin entity)
+		{
+			this.SendPropertyChanging();
+			entity.Plugin = null;
+		}
+	}
+	
+	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.ResourcePlugin")]
+	public partial class ResourcePlugin : INotifyPropertyChanging, INotifyPropertyChanged
+	{
+		
+		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
+		
+		private System.Guid _ResourceId;
+		
+		private System.Guid _PluginId;
+		
+		private EntityRef<Plugin> _Plugin;
+		
+		private EntityRef<Resource> _Resource;
+		
     #region Extensibility Method Definitions
     partial void OnLoaded();
@@ -1999,131 +2230,163 @@
     partial void OnPluginIdChanged();
     #endregion
-
-    public ResourcePlugin() {
-      this._Plugin = default(EntityRef<Plugin>);
-      this._Resource = default(EntityRef<Resource>);
-      OnCreated();
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_ResourceId", DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true)]
-    public System.Guid ResourceId {
-      get {
-        return this._ResourceId;
-      }
-      set {
-        if ((this._ResourceId != value)) {
-          if (this._Resource.HasLoadedOrAssignedValue) {
-            throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
-          }
-          this.OnResourceIdChanging(value);
-          this.SendPropertyChanging();
-          this._ResourceId = value;
-          this.SendPropertyChanged("ResourceId");
-          this.OnResourceIdChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_PluginId", DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true)]
-    public System.Guid PluginId {
-      get {
-        return this._PluginId;
-      }
-      set {
-        if ((this._PluginId != value)) {
-          if (this._Plugin.HasLoadedOrAssignedValue) {
-            throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
-          }
-          this.OnPluginIdChanging(value);
-          this.SendPropertyChanging();
-          this._PluginId = value;
-          this.SendPropertyChanged("PluginId");
-          this.OnPluginIdChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Plugin_ResourcePlugin", Storage = "_Plugin", ThisKey = "PluginId", OtherKey = "Id", IsForeignKey = true)]
-    public Plugin Plugin {
-      get {
-        return this._Plugin.Entity;
-      }
-      set {
-        Plugin previousValue = this._Plugin.Entity;
-        if (((previousValue != value)
-              || (this._Plugin.HasLoadedOrAssignedValue == false))) {
-          this.SendPropertyChanging();
-          if ((previousValue != null)) {
-            this._Plugin.Entity = null;
-            previousValue.ResourcePlugins.Remove(this);
-          }
-          this._Plugin.Entity = value;
-          if ((value != null)) {
-            value.ResourcePlugins.Add(this);
-            this._PluginId = value.Id;
-          } else {
-            this._PluginId = default(System.Guid);
-          }
-          this.SendPropertyChanged("Plugin");
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "Resource_ResourcePlugin", Storage = "_Resource", ThisKey = "ResourceId", OtherKey = "Id", IsForeignKey = true)]
-    public Resource Resource {
-      get {
-        return this._Resource.Entity;
-      }
-      set {
-        Resource previousValue = this._Resource.Entity;
-        if (((previousValue != value)
-              || (this._Resource.HasLoadedOrAssignedValue == false))) {
-          this.SendPropertyChanging();
-          if ((previousValue != null)) {
-            this._Resource.Entity = null;
-            previousValue.ResourcePlugins.Remove(this);
-          }
-          this._Resource.Entity = value;
-          if ((value != null)) {
-            value.ResourcePlugins.Add(this);
-            this._ResourceId = value.Id;
-          } else {
-            this._ResourceId = default(System.Guid);
-          }
-          this.SendPropertyChanged("Resource");
-        }
-      }
-    }
-
-    public event PropertyChangingEventHandler PropertyChanging;
-
-    public event PropertyChangedEventHandler PropertyChanged;
-
-    protected virtual void SendPropertyChanging() {
-      if ((this.PropertyChanging != null)) {
-        this.PropertyChanging(this, emptyChangingEventArgs);
-      }
-    }
-
-    protected virtual void SendPropertyChanged(String propertyName) {
-      if ((this.PropertyChanged != null)) {
-        this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
-      }
-    }
-  }
-
-  [global::System.Data.Linq.Mapping.TableAttribute(Name = "dbo.UserGroupUserGroup")]
-  public partial class UserGroupUserGroup : INotifyPropertyChanging, INotifyPropertyChanged {
-
-    private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
-
-    private System.Guid _UserGroupId;
-
-    private System.Guid _UserGroupUserGroupId;
-
-    private EntityRef<UserGroupBase> _UserGroup;
-
-    private EntityRef<UserGroupBase> _UserGroupBase;
-
+		
+		public ResourcePlugin()
+		{
+			this._Plugin = default(EntityRef<Plugin>);
+			this._Resource = default(EntityRef<Resource>);
+			OnCreated();
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_ResourceId", DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true)]
+		public System.Guid ResourceId
+		{
+			get
+			{
+				return this._ResourceId;
+			}
+			set
+			{
+				if ((this._ResourceId != value))
+				{
+					if (this._Resource.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnResourceIdChanging(value);
+					this.SendPropertyChanging();
+					this._ResourceId = value;
+					this.SendPropertyChanged("ResourceId");
+					this.OnResourceIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_PluginId", DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true)]
+		public System.Guid PluginId
+		{
+			get
+			{
+				return this._PluginId;
+			}
+			set
+			{
+				if ((this._PluginId != value))
+				{
+					if (this._Plugin.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnPluginIdChanging(value);
+					this.SendPropertyChanging();
+					this._PluginId = value;
+					this.SendPropertyChanged("PluginId");
+					this.OnPluginIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Plugin_ResourcePlugin", Storage="_Plugin", ThisKey="PluginId", OtherKey="Id", IsForeignKey=true)]
+		public Plugin Plugin
+		{
+			get
+			{
+				return this._Plugin.Entity;
+			}
+			set
+			{
+				Plugin previousValue = this._Plugin.Entity;
+				if (((previousValue != value) 
+							|| (this._Plugin.HasLoadedOrAssignedValue == false)))
+				{
+					this.SendPropertyChanging();
+					if ((previousValue != null))
+					{
+						this._Plugin.Entity = null;
+						previousValue.ResourcePlugins.Remove(this);
+					}
+					this._Plugin.Entity = value;
+					if ((value != null))
+					{
+						value.ResourcePlugins.Add(this);
+						this._PluginId = value.Id;
+					}
+					else
+					{
+						this._PluginId = default(System.Guid);
+					}
+					this.SendPropertyChanged("Plugin");
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="Resource_ResourcePlugin", Storage="_Resource", ThisKey="ResourceId", OtherKey="Id", IsForeignKey=true)]
+		public Resource Resource
+		{
+			get
+			{
+				return this._Resource.Entity;
+			}
+			set
+			{
+				Resource previousValue = this._Resource.Entity;
+				if (((previousValue != value) 
+							|| (this._Resource.HasLoadedOrAssignedValue == false)))
+				{
+					this.SendPropertyChanging();
+					if ((previousValue != null))
+					{
+						this._Resource.Entity = null;
+						previousValue.ResourcePlugins.Remove(this);
+					}
+					this._Resource.Entity = value;
+					if ((value != null))
+					{
+						value.ResourcePlugins.Add(this);
+						this._ResourceId = value.Id;
+					}
+					else
+					{
+						this._ResourceId = default(System.Guid);
+					}
+					this.SendPropertyChanged("Resource");
+				}
+			}
+		}
+		
+		public event PropertyChangingEventHandler PropertyChanging;
+		
+		public event PropertyChangedEventHandler PropertyChanged;
+		
+		protected virtual void SendPropertyChanging()
+		{
+			if ((this.PropertyChanging != null))
+			{
+				this.PropertyChanging(this, emptyChangingEventArgs);
+			}
+		}
+		
+		protected virtual void SendPropertyChanged(String propertyName)
+		{
+			if ((this.PropertyChanged != null))
+			{
+				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
+			}
+		}
+	}
+	
+	[global::System.Data.Linq.Mapping.TableAttribute(Name="dbo.UserGroupUserGroup")]
+	public partial class UserGroupUserGroup : INotifyPropertyChanging, INotifyPropertyChanged
+	{
+		
+		private static PropertyChangingEventArgs emptyChangingEventArgs = new PropertyChangingEventArgs(String.Empty);
+		
+		private System.Guid _UserGroupId;
+		
+		private System.Guid _UserGroupUserGroupId;
+		
+		private EntityRef<UserGroupBase> _UserGroup;
+		
+		private EntityRef<UserGroupBase> _UserGroupBase;
+		
     #region Extensibility Method Definitions
     partial void OnLoaded();
@@ -2135,117 +2398,148 @@
     partial void OnUserGroupUserGroupIdChanged();
     #endregion
-
-    public UserGroupUserGroup() {
-      this._UserGroup = default(EntityRef<UserGroupBase>);
-      this._UserGroupBase = default(EntityRef<UserGroupBase>);
-      OnCreated();
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_UserGroupId", DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true)]
-    public System.Guid UserGroupId {
-      get {
-        return this._UserGroupId;
-      }
-      set {
-        if ((this._UserGroupId != value)) {
-          if (this._UserGroup.HasLoadedOrAssignedValue) {
-            throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
-          }
-          this.OnUserGroupIdChanging(value);
-          this.SendPropertyChanging();
-          this._UserGroupId = value;
-          this.SendPropertyChanged("UserGroupId");
-          this.OnUserGroupIdChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.ColumnAttribute(Storage = "_UserGroupUserGroupId", DbType = "UniqueIdentifier NOT NULL", IsPrimaryKey = true)]
-    public System.Guid UserGroupUserGroupId {
-      get {
-        return this._UserGroupUserGroupId;
-      }
-      set {
-        if ((this._UserGroupUserGroupId != value)) {
-          if (this._UserGroupBase.HasLoadedOrAssignedValue) {
-            throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
-          }
-          this.OnUserGroupUserGroupIdChanging(value);
-          this.SendPropertyChanging();
-          this._UserGroupUserGroupId = value;
-          this.SendPropertyChanged("UserGroupUserGroupId");
-          this.OnUserGroupUserGroupIdChanged();
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "UserGroupBase_UserGroupUserGroup", Storage = "_UserGroup", ThisKey = "UserGroupId", OtherKey = "Id", IsForeignKey = true)]
-    public UserGroupBase UserGroup {
-      get {
-        return this._UserGroup.Entity;
-      }
-      set {
-        UserGroupBase previousValue = this._UserGroup.Entity;
-        if (((previousValue != value)
-              || (this._UserGroup.HasLoadedOrAssignedValue == false))) {
-          this.SendPropertyChanging();
-          if ((previousValue != null)) {
-            this._UserGroup.Entity = null;
-            previousValue.UserGroupUserGroupsChilds.Remove(this);
-          }
-          this._UserGroup.Entity = value;
-          if ((value != null)) {
-            value.UserGroupUserGroupsChilds.Add(this);
-            this._UserGroupId = value.Id;
-          } else {
-            this._UserGroupId = default(System.Guid);
-          }
-          this.SendPropertyChanged("UserGroup");
-        }
-      }
-    }
-
-    [global::System.Data.Linq.Mapping.AssociationAttribute(Name = "UserGroupBase_UserGroupUserGroup1", Storage = "_UserGroupBase", ThisKey = "UserGroupUserGroupId", OtherKey = "Id", IsForeignKey = true)]
-    public UserGroupBase UserGroupBase {
-      get {
-        return this._UserGroupBase.Entity;
-      }
-      set {
-        UserGroupBase previousValue = this._UserGroupBase.Entity;
-        if (((previousValue != value)
-              || (this._UserGroupBase.HasLoadedOrAssignedValue == false))) {
-          this.SendPropertyChanging();
-          if ((previousValue != null)) {
-            this._UserGroupBase.Entity = null;
-            previousValue.UserGroupUserGroupsParents.Remove(this);
-          }
-          this._UserGroupBase.Entity = value;
-          if ((value != null)) {
-            value.UserGroupUserGroupsParents.Add(this);
-            this._UserGroupUserGroupId = value.Id;
-          } else {
-            this._UserGroupUserGroupId = default(System.Guid);
-          }
-          this.SendPropertyChanged("UserGroupBase");
-        }
-      }
-    }
-
-    public event PropertyChangingEventHandler PropertyChanging;
-
-    public event PropertyChangedEventHandler PropertyChanged;
-
-    protected virtual void SendPropertyChanging() {
-      if ((this.PropertyChanging != null)) {
-        this.PropertyChanging(this, emptyChangingEventArgs);
-      }
-    }
-
-    protected virtual void SendPropertyChanged(String propertyName) {
-      if ((this.PropertyChanged != null)) {
-        this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
-      }
-    }
-  }
+		
+		public UserGroupUserGroup()
+		{
+			this._UserGroup = default(EntityRef<UserGroupBase>);
+			this._UserGroupBase = default(EntityRef<UserGroupBase>);
+			OnCreated();
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_UserGroupId", DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true)]
+		public System.Guid UserGroupId
+		{
+			get
+			{
+				return this._UserGroupId;
+			}
+			set
+			{
+				if ((this._UserGroupId != value))
+				{
+					if (this._UserGroup.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnUserGroupIdChanging(value);
+					this.SendPropertyChanging();
+					this._UserGroupId = value;
+					this.SendPropertyChanged("UserGroupId");
+					this.OnUserGroupIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.ColumnAttribute(Storage="_UserGroupUserGroupId", DbType="UniqueIdentifier NOT NULL", IsPrimaryKey=true)]
+		public System.Guid UserGroupUserGroupId
+		{
+			get
+			{
+				return this._UserGroupUserGroupId;
+			}
+			set
+			{
+				if ((this._UserGroupUserGroupId != value))
+				{
+					if (this._UserGroupBase.HasLoadedOrAssignedValue)
+					{
+						throw new System.Data.Linq.ForeignKeyReferenceAlreadyHasValueException();
+					}
+					this.OnUserGroupUserGroupIdChanging(value);
+					this.SendPropertyChanging();
+					this._UserGroupUserGroupId = value;
+					this.SendPropertyChanged("UserGroupUserGroupId");
+					this.OnUserGroupUserGroupIdChanged();
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="UserGroupBase_UserGroupUserGroup", Storage="_UserGroup", ThisKey="UserGroupId", OtherKey="Id", IsForeignKey=true)]
+		public UserGroupBase UserGroup
+		{
+			get
+			{
+				return this._UserGroup.Entity;
+			}
+			set
+			{
+				UserGroupBase previousValue = this._UserGroup.Entity;
+				if (((previousValue != value) 
+							|| (this._UserGroup.HasLoadedOrAssignedValue == false)))
+				{
+					this.SendPropertyChanging();
+					if ((previousValue != null))
+					{
+						this._UserGroup.Entity = null;
+						previousValue.UserGroupUserGroupsChilds.Remove(this);
+					}
+					this._UserGroup.Entity = value;
+					if ((value != null))
+					{
+						value.UserGroupUserGroupsChilds.Add(this);
+						this._UserGroupId = value.Id;
+					}
+					else
+					{
+						this._UserGroupId = default(System.Guid);
+					}
+					this.SendPropertyChanged("UserGroup");
+				}
+			}
+		}
+		
+		[global::System.Data.Linq.Mapping.AssociationAttribute(Name="UserGroupBase_UserGroupUserGroup1", Storage="_UserGroupBase", ThisKey="UserGroupUserGroupId", OtherKey="Id", IsForeignKey=true)]
+		public UserGroupBase UserGroupBase
+		{
+			get
+			{
+				return this._UserGroupBase.Entity;
+			}
+			set
+			{
+				UserGroupBase previousValue = this._UserGroupBase.Entity;
+				if (((previousValue != value) 
+							|| (this._UserGroupBase.HasLoadedOrAssignedValue == false)))
+				{
+					this.SendPropertyChanging();
+					if ((previousValue != null))
+					{
+						this._UserGroupBase.Entity = null;
+						previousValue.UserGroupUserGroupsParents.Remove(this);
+					}
+					this._UserGroupBase.Entity = value;
+					if ((value != null))
+					{
+						value.UserGroupUserGroupsParents.Add(this);
+						this._UserGroupUserGroupId = value.Id;
+					}
+					else
+					{
+						this._UserGroupUserGroupId = default(System.Guid);
+					}
+					this.SendPropertyChanged("UserGroupBase");
+				}
+			}
+		}
+		
+		public event PropertyChangingEventHandler PropertyChanging;
+		
+		public event PropertyChangedEventHandler PropertyChanged;
+		
+		protected virtual void SendPropertyChanging()
+		{
+			if ((this.PropertyChanging != null))
+			{
+				this.PropertyChanging(this, emptyChangingEventArgs);
+			}
+		}
+		
+		protected virtual void SendPropertyChanged(String propertyName)
+		{
+			if ((this.PropertyChanged != null))
+			{
+				this.PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
+			}
+		}
+	}
 }
 #pragma warning restore 1591
